/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "player.h"

void playerCreate(entitysystem_t *system, int32_t index) {
  system->entities[index] = ENTITY_TYPE_PLAYER;
  system->callbacks[index].dispose = &playerDispose;
  system->callbacks[index].render = &playerRender;
  system->positions[index].x = 0;
  system->positions[index].y = 0;
  system->positions[index].z = 0;
  system->primitives[index] = quadCreate(0,
    0, 0, 0, 0,
    1, 1, 1, 1
  );
}

void playerDispose(entitysystem_t *system, int32_t index) {
}

void playerRender(entitysystem_t *system, int32_t index,
  shader_t *shader, camera_t *camera,
  input_t *input
) {
  shaderUsePosition(shader,
    system->positions[index].x,
    system->positions[index].y,
    system->positions[index].z,
    0, 0, 0
  );
  primitiveDraw(system->primitives[index],
    0, system->primitives[index]->indiceCount
  );
}
